__precompile__(false)
module JulGame
    using SimpleDirectMediaLayer
    const SDL2 = SimpleDirectMediaLayer 

    SDL2.init()
    export SDL2
    
    include("Macros.jl")
    using .Macros: @event
    export @event

    include("Math/Math.jl")
    using .Math: Math
    export Math

    include("Input/Input.jl")
    using .InputModule: Input
    export Input

    include("Main.jl") 
    using .MainLoop: Main   
    const MAIN = Main(1.0)
    export MAIN

    include("UI/UI.jl")
    using .UI
    export ScreenButtonModule, TextBoxModule

    export Component
    include("Component/Component.jl")
    using .Component
    export AnimationModule, AnimatorModule, ColliderModule, RigidbodyModule, SoundSourceModule, SpriteModule, TransformModule

    include("Entity.jl") 
    using .EntityModule   
    export Entity

    export SceneManagement
    include("SceneManagement/SceneManagement.jl")
    using .SceneManagement
    export SceneBuilderModule, SceneLoaderModule, SceneReaderModule, SceneWriterModule 

    include("../editor/Editor/Editor.jl")
    using .Editor
    export Editor 
end